# Leetcode Binary-Tree-Inorder-Traversal

#### 2022-07-04 15:42

> ##### Algorithms:
>
> #algorithm #DFS #DFS_inorder
>
> ##### Data structures:
>
> #DS #binary_tree
>
> ##### Difficulty:
>
> #coding_problems #difficulty_easy
>
> ##### Additional tags:
>
> #leetcode
>
> ##### Revisions:
>
> N/A

##### Related topics:

##### Links:

- [Link to problem](https://leetcode.com/problems/binary-tree-inorder-traversal/)

  ***

### Problem

Given the `root` of a binary tree, return _the inorder traversal of its nodes' values_.

#### Examples

**Example 1:**

![](https://assets.leetcode.com/uploads/2020/09/15/inorder_1.jpg)

**Input:** root = [1,null,2,3]
**Output:** [1,3,2]

**Example 2:**

**Input:** root = []
**Output:** []

**Example 3:**

**Input:** root = [1]
**Output:** [1]

#### Constraints

- The number of nodes in the tree is in the range `[0, 100]`.
- `-100 <= Node.val <= 100`

### Thoughts

> [!summary]
> This is a #DFS traversal problem

Many of them are same to [[Leetcode Binary-Tree-Preorder-Traversal]]

### Solution

Recursion

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode() : val(0), left(nullptr), right(nullptr) {}
 *     TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
 *     TreeNode(int x, TreeNode *left, TreeNode *right) : val(x), left(left),
 * right(right) {}
 * };
 */
class Solution {
void inorder(TreeNode *root, vector<int> &answer) {
  if (!root) {
    return;
  }

  inorder(root->left, answer);
  answer.push_back(root->val);
  inorder(root->right, answer);
}

public:
vector<int> inorderTraversal(TreeNode *root) {
  // Recursion.
  vector<int> answer;
  inorder(root, answer);
  return answer;
}
};
```

Iteration

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode() : val(0), left(nullptr), right(nullptr) {}
 *     TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
 *     TreeNode(int x, TreeNode *left, TreeNode *right) : val(x), left(left),
 * right(right) {}
 * };
 */
class Solution {
public:
vector<int> inorderTraversal(TreeNode *root) {
  // Iteration
  stack<TreeNode *> pending;
  vector<int> answer;

  while (root || !pending.empty()) {
    // traverse left first.
    while (root) {
      pending.push(root);
      root = root->left;
    }

    root = pending.top();
    pending.pop();
    answer.push_back(root->val);
    root = root->right;
  }

  return answer;
}
};

```
