# Leetcode Implement-Queue-Using-Stacks

#### 2022-07-03 09:52

> ##### Data structures:
>
> #DS #stack #queue
>
> ##### Difficulty:
>
> #coding_problems #difficulty_easy
>
> ##### Additional tags:
>
> #leetcode #CS_list_need_understanding
>
> ##### Revisions:
>
> 2022-09-21

##### Related topics:

##### Links:

- [Link to problem](https://leetcode.com/problems/implement-queue-using-stacks/)

  ***

### Problem

Implement a first in first out (FIFO) queue using only two stacks. The implemented queue should support all the functions of a normal queue (`push`, `peek`, `pop`, and `empty`).

Implement the `MyQueue` class:

- `void push(int x)` Pushes element x to the back of the queue.
- `int pop()` Removes the element from the front of the queue and returns it.
- `int peek()` Returns the element at the front of the queue.
- `boolean empty()` Returns `true` if the queue is empty, `false` otherwise.

  **Notes:**

- You must use **only** standard operations of a stack, which means only `push to top`, `peek/pop from top`, `size`, and `is empty` operations are valid.
- Depending on your language, the stack may not be supported natively. You may simulate a stack using a list or deque (double-ended queue) as long as you use only a stack's standard operations.

#### Examples

**Input**

```
["MyQueue", "push", "push", "peek", "pop", "empty"]
[[], [1], [2], [], [], []]
```

**Output**

```
[null, null, null, 1, 1, false]
```

**Explanation**

```
MyQueue myQueue = new MyQueue();
myQueue.push(1); // queue is: [1]
myQueue.push(2); // queue is: [1, 2] (leftmost is front of the queue)
myQueue.peek(); // return 1
myQueue.pop(); // return 1, queue is [2]
myQueue.empty(); // return false
```

#### Constraints

**Constraints:**

- `1 <= x <= 9`
- At most `100` calls will be made to `push`, `pop`, `peek`, and `empty`.
- All the calls to `pop` and `peek` are valid.

### Thoughts

> [!summary]
> Use two stacks to implement a queue.

One stack reverse the FIFO order, but two stack can reverse back.

In real life, this can improve speed as you only lock one stack because of thread safety.

### Solution

```cpp
class MyQueue {
stack<int> input;
stack<int> out;

public:
void push(int x) { input.push(x); }

int pop() {
  move();
  int top = out.top();
  out.pop();
  return top;
}

int peek() {
  move();
  return out.top();
}

void move() {
  if (out.empty()) {
    while (!input.empty()) {
      out.push(input.top());
      input.pop();
    }
  }
}

bool empty() { return input.empty() && out.empty(); }
};

/**
 * Your MyQueue object will be instantiated and called as such:
 * MyQueue* obj = new MyQueue();
 * obj->push(x);
 * int param_2 = obj->pop();
 * int param_3 = obj->peek();
 * bool param_4 = obj->empty();
 */
```
